//	CZT[BMP180gp OttLCDxECv
//	wt]xH쎺	@jsdiy	http://jsdiy.webcrow.jp

/*
y|[gΉz	ATmega328P	x:݂Ȃ(PC6RESET) -:
bit		7	6	5	4	3	2	1	0
portB	-	-	-	-	-	-	-	-		
portC	x	*	SCL	SDA	-	-	-	-		I2C
portD	-	LCD	LCD	-	LCD	LCD	LCD	LCD		LCD

yATmega88z
|CCCCCC---BBBBB|
|543210GRV54321|
>              |
|601234VG675670|
|CDDDDD--BBDDDB|

yq[Yrbgz(ftavrw.exe -rf)
yATmega88z	Hoאݒ Low:01100010(62), Hi:11011111(DF)
Low: 01100010 (62)
     ||||++++-- CKSEL[3:0] VXeNbNI
     ||++-- SUT[1:0] N
     |+-- CKOUT (0:PB0ɃVXeNbNo)
     +-- CKDIV8 NbNl (1:1/1, 0:1/8)

High:11-11111 (DF)
     |||||+++-- BODLEVEL[2:0] (111:, 110:1.8V, 101:2.7V, 100:4.3V)
     ||||+-- EESAVE (EEPROM 1:, 0:ێ)
     |||+-- WDTON (1:WDTʏ퓮, 0:WDT펞ON)
     ||+-- SPIEN (1:ISP֎~, 0:ISP) Parallel̂
     |+-- DWEN (On-ChipfobO 1:, 0:L)
     +-- RSTDISBL (RESETs 1:L, 0:(PC6))

Ext: -----001 (F9)
          ||+-- BOOTRST f[^V[gQ
          ++-- BOOTSZ[1:0] f[^V[gQ

  
VXeNbNᑬȂ̂Œʏ푀łftavrw.exeœǂݏłȂBu-br9600vIvVw肷邱ƁB

yrhz
Atmel Studio 7 (Version: 7.0.1931 - )
ATmega88V	8MHzi8MHz/32=250kHz쓮j
*/
/*
yXVz
2020/04/15	v1.00	
	Program Memory Usage 	:	4194 bytes   12.8 % Full
	Data Memory Usage 		:	101 bytes   4.9 % Full
	EEPROM Memory Usage 	:	62 bytes   6.1 % Full
	
2020/04/16	v1.10
	Eԑ҂_delay_ms()X[v֕ύX
	EVXeNbN500kHz
		Program Memory Usage 	:	4226 bytes   12.9 % Full
		Data Memory Usage 		:	101 bytes   4.9 % Full
		EEPROM Memory Usage 	:	62 bytes   6.1 % Full

2020/05/01	v2.00
	ELN^LCDI2Cڑł͂Ȃڂ̐ڑɕύX
	EATmega328PATmega88V֕ύXAō쐻Ċ
		Program Memory Usage 	:	4368 bytes   53.3 % Full
		Data Memory Usage 		:	105 bytes   10.3 % Full
		EEPROM Memory Usage 	:	62 bytes   12.1 % Full

2020/05/10	v2.10
	EOt\ɂāAgXP[O͂Ȃ悤ύXiĈ킸ȕϓUɌ̂ŁBC\ɂ͉eȂj
	EVXeNbN500kHz250kHz֕ύX
		Program Memory Usage 	:	4400 bytes   53.7 % Full
		Data Memory Usage 		:	105 bytes   10.3 % Full
		EEPROM Memory Usage 	:	62 bytes   12.1 % Full
*/

#include <avr/io.h>
#include <avr/pgmspace.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include <util/delay.h>
#include "twilib.h"
#include "clcd/HD44780_lcdlib.h"
#include "appdefine.h"
#include "bmp180lib.h"
#include "dataaccess.h"

//[U[`̕R[h
enum EUserCharID
{
	CharID_TEMP_1, CharID_TEMP_2, CharID_TEMP_3,
	CharID_PRES_1, CharID_PRES_2, CharID_PRES_3
};

//Ot쐬p̃obt@i[U[`3j
static	uint8_t userdef1[8], userdef2[8], userdef3[8];
static	uint8_t* dotPattern[] = { userdef1, userdef2, userdef3 };

//l
static	TSensorValue	sensorValue;

//֐
static	void	WaitSec(uint8_t sec);
static	void	WaitMinute(uint8_t minute);
static	void	DrawInitScreen(void);
static	void	DrawSensorValueTemperature(const BMP180_TDecimal* num);
static	void	DrawSensorValuePressure(const BMP180_TDecimal* num);
static	void	DrawGraphTemperature(void);
static	void	DrawGraphPressure(void);
static	void	CreateGraphDotPattern(ESensorType sensorType);
static	void	ClearDotPattern(void);


//荞
ISR(TIMER2_OVF_vect)
{
	//X[v
}

int main(void)
{	
	_delay_ms(100);
	
	//S|[gvAbvigpI/Os͌Ōʂɐݒ肷j
	DDRB = 0x00;	PORTB = 0xFF;
	DDRC = 0x00;	PORTC = 0xFF;
	DDRD = 0x00;	PORTD = 0xFF;
	
	//d͍팸i0:gp, 1:gpj
	PRR		=	(0<<PRTWI) | (0<<PRTIM2) | (1<<PRTIM0) | (1<<PRTIM1) | (1<<PRSPI) | (1<<PRUSART0) | (1<<PRADC);
	ACSR	=	(1<<ACD);
	
	//VXeNbNᑬ
	//E250kHzɂ1bvȂȂ̂ŒӁi1̃I[o[t[荞݂1bȏォjB
	CLKPR = (1 << CLKPCE);
	CLKPR = (0b0101 << CLKPS0);	//0000:1(8MHz), c, 0011:8(1MHz), 0100:16(500kHz), 0101:32(250kHz)
	
	//^C}[^JE^[2ݒ肷
	//WGM22,21,20 = 000:W
	//CS22,21,20 = 000:^C}[~, 001:Ȃ, 010:8, 011:32, 100:64, 101:128, 110:256, 111:1024
	TCCR2B = (1 << CS22) | (1 << CS21) | (1 << CS20);	//111=clk/1024
	TIMSK2 = (1 << TOIE2);
	set_sleep_mode(SLEEP_MODE_PWR_SAVE);
	
	//I2C,LCD
	TWI_MasterInit();
	LCD_Init(16, 2);
	LCD_SetLineMode(LCD_LINEMODE_SEPARATE | LCD_LINEMODE_STOP, LCD_CURSOR_OFF);
	
	//ZT[
	uint8_t isOK = BMP180_Init();
	if (!isOK)
	{
		LCD_PutString("Init Error");
		goto FINISH;
	}
	
	//̑̏Ȃ
	DA_Init();
	DrawInitScreen();
	
	while (1)
	{
		//肷
		BMP180_GetTemperature(&sensorValue.temp);
		BMP180_GetPressure(&sensorValue.pres, BMP180_OSS_UltraHighResolution);
		
		//l\
		DrawSensorValueTemperature(&sensorValue.temp);
		DrawSensorValuePressure(&sensorValue.pres);
		
		//Ot`悷
		DrawGraphTemperature();
		DrawGraphPressure();
		
		//񑪒܂ł̎ԑ҂
		WaitMinute(20);
		
		//lۑ
		//El̕ۑ^C~Oԑ҂̑OɂƁA
		//	ZԂɓdon/offꍇɂ̓sxlۑ邱ƂɂȂB
		//	邽߁Aԑ҂ɕۑB
		DA_Save(&sensorValue);
	}

FINISH:
	return 0;
}

//b҂
static	void	WaitSec(uint8_t sec)
{
	sei();
	for (uint8_t s = 0; s < sec; s++)
	{
		//xxHz/1024/I[o[t[܂256JEg = I[o[t[n1bo
		for (uint8_t i = 0; i < F_CPU / 1024 / 256 + 0.5f; i++) { sleep_mode(); }
	}
	cli();
}

//҂
static	void	WaitMinute(uint8_t minute)
{
	for (uint8_t m = 0; m < minute; m++) { WaitSec(60); }
}

//ʂ`悷
static	void	DrawInitScreen(void)
{
	LCD_Clear();
	
	LCD_SetPos(0, 0);	LCD_PutString("");
	LCD_SetPos(0, 9);	LCD_PutString("'C");
	
	LCD_SetPos(1, 0);	LCD_PutString("");
	LCD_SetPos(1, 9);	LCD_PutString("hPa");
}

//l`悷ixj
static	void	DrawSensorValueTemperature(const BMP180_TDecimal* num)
{
	LCD_SetPos(0, 4);
	if (0 <= num->integer && num->integer <= 9) { LCD_PutChar(' '); }
	LCD_PutInt(num->integer);	LCD_PutChar('.');	LCD_PutUInt(num->decimal);
	if (-9 <= num->integer) { LCD_PutChar(' '); }
}

//l`悷iCj
static	void	DrawSensorValuePressure(const BMP180_TDecimal* num)
{
	LCD_SetPos(1, 4);
	if (num->integer < 1000) { LCD_PutChar(' '); }
	LCD_PutInt(num->integer);
}

//Ot`悷ixj
static	void	DrawGraphTemperature(void)
{
	//hbgp^[ŃOt쐬
	CreateGraphDotPattern(SENSOR_Temperature);

	//hbgp^[[U[`ɂ
	LCD_DefChar(CharID_TEMP_1, dotPattern[0]);
	LCD_DefChar(CharID_TEMP_2, dotPattern[1]);
	LCD_DefChar(CharID_TEMP_3, dotPattern[2]);
	
	//Ot`
	LCD_SetPos(0, 13);
	LCD_PutChar(CharID_TEMP_1);	LCD_PutChar(CharID_TEMP_2);	LCD_PutChar(CharID_TEMP_3);
}

//Ot`悷iCj
static	void	DrawGraphPressure(void)
{
	//hbgp^[ŃOt쐬
	CreateGraphDotPattern(SENSOR_Pressure);
	
	//hbgp^[[U[`ɂ
	LCD_DefChar(CharID_PRES_1, dotPattern[0]);
	LCD_DefChar(CharID_PRES_2, dotPattern[1]);
	LCD_DefChar(CharID_PRES_3, dotPattern[2]);
	
	//Ot`
	LCD_SetPos(1, 13);
	LCD_PutChar(CharID_PRES_1);	LCD_PutChar(CharID_PRES_2);	LCD_PutChar(CharID_PRES_3);
}

//hbgp^[ŃOt쐬
static	void	CreateGraphDotPattern(ESensorType sensorType)
{
	//Otp̃f[^ǂݍ
	TGraphParam grParam;
	DA_LoadGraphParam(sensorType, &grParam);
	
	//XP[O
	//E7hbgɎ߂邽߁Af[^l0`6ɕϊB
	//EOt꒼ɂȂꍇiőlEŏl̍0jA̍ʒui3hbgjɂB
	//EOt̕ϓꍇiőlEŏl̍6ȉjAXP[OigjȂB
	uint16_t diff = grParam.max - grParam.min;
	
	for (uint8_t i = 0; i < GRAPHPARAM_LENGTH; i++)
	{
		if (grParam.datas[i] == DA_NO_DATA) { continue; }
		
		uint16_t n = grParam.datas[i] - grParam.min;
		if (diff == 0)
		{
			grParam.datas[i] = 6 / 2;	//̍
		}
		else if (diff <= 6)
		{
			//grParam.datas[i] = n;	//7hbg̒Ⴂʒu
			grParam.datas[i] = (6 - diff) / 2 + n;	//̍t߂̈ʒu
		}
		else
		{
			grParam.datas[i] = n * 6 / diff;	//k
		}
	}
	
	//[U[`̃hbgp^[쐬i15x7hbgj
	ClearDotPattern();
	
	for (uint8_t i = 0; i < GRAPHPARAM_LENGTH; i++)
	{
		if (grParam.datas[i] == DA_NO_DATA) { continue; }
		uint8_t paramData = (uint8_t)grParam.datas[i];
		
		uint8_t c = i / 5;				//ڂɊ܂܂_i[0]`[2]3j
		uint8_t line = 6 - paramData;	//ォ牽sڂ̓_([0]`[6]7s)
		uint8_t left = i % 5;			//牽hbgڂ̓_i[0]`[4]5hbgj
		uint8_t bit = 1 << (4 - left);	//ł_0b00010̂悤ɒlŕ\
		for ( ; line < 7; line++) { dotPattern[c][line] |= bit; }	//ړI̓_ŉs܂œ_łicɂj
	}
}

//[U[`̃obt@NA
static	void	ClearDotPattern(void)
{
	for (uint8_t c = 0; c < 3; c++)
	{
		for (uint8_t line = 0; line < 8; line++) { dotPattern[c][line] = 0x00; }
	}
}
